﻿using System.Runtime.InteropServices;

class Program
{
    static async Task<int> Main(string[] args)
    {
        long result = await Sum.CalcAsync(100);
        Console.WriteLine(result);
        
        result = await Sum.CalcAsync(100);
        Console.WriteLine(result);
        return 0;
    }
}

public class Sum
{
    static Dictionary<int, long> _cache = new Dictionary<int, long>();

    public static Task<long> CalcAsync(int n)
    {
        if (_cache.ContainsKey(n) == true)
        {
            return Task.FromResult(_cache[n]);
        }

        return Task.Run<long>(() =>
        {
            long sum = 0;
            for (int i = 1; i <= n; i++)
            {
                sum += i;
            }

            _cache[n] = sum;
            return sum;
        });
    }


    public static ValueTask<long> CalcValueAsync(int n)
    {
        if (_cache.ContainsKey(n) == true)
        {
            return new ValueTask<long>(_cache[n]);
        }

        Task<long> task = Task.Run<long>(() =>
        {
            long sum = 0;
            for (int i = 1; i <= n; i++)
            {
                sum += i;
            }

            _cache[n] = sum;
            return sum;
        });

        return new ValueTask<long>(task);
    }
}